wibble::ParseContext< Token, Stream > Struct Template Reference

`#include <parse.h>`

## Classes

struct | Fail

## Public Types

typedef ParseContext< Token, Stream > | This

## Public Member Functions

Stream & | stream ()
void | clearErrors ()
void | error (std::ostream &o, std::string prefix, const Fail &fail)
void | errors (std::ostream &o)
Token | remove ()
void | rewind (int n)
This & | createChild (Stream &s, std::string name)
| ParseContext (Stream &s, std::string name)

## Public Attributes

Stream * | _stream
std::deque< Token > | window
int | window_pos
int | position
std::string | name
std::vector< This > | children
std::priority_queue< Fail > | failures

## Member Typedef Documentation

## This

template<typename Token , typename Stream >

typedef ParseContext< Token, Stream > wibble::ParseContext< Token, Stream >::This

## Constructor & Destructor Documentation

## ParseContext()

template<typename Token , typename Stream >

wibble::ParseContext< Token, Stream >::ParseContext | ( | Stream & | s,
|  | std::string | name
| ) |  |

inline

## Member Function Documentation

## clearErrors()

template<typename Token , typename Stream >

void wibble::ParseContext< Token, Stream >::clearErrors | ( |  | ) |

inline

## createChild()

template<typename Token , typename Stream >

This& wibble::ParseContext< Token, Stream >::createChild | ( | Stream & | s,
|  | std::string | name
| ) |  |

inline

## error()

template<typename Token , typename Stream >

void wibble::ParseContext< Token, Stream >::error | ( | std::ostream & | o,
|  | std::string | prefix,
|  | const Fail & | fail
| ) |  |

inline

References wibble::Position::column, wibble::Token< _Id >::data, wibble::ParseContext< Token, Stream >::Fail::expected, wibble::Token< _Id >::id, wibble::Position::line, wibble::Token< _Id >::position, wibble::ParseContext< Token, Stream >::Fail::position, and wibble::ParseContext< Token, Stream >::Fail::type.

## errors()

template<typename Token , typename Stream >

void wibble::ParseContext< Token, Stream >::errors | ( | std::ostream & | o | ) |

inline

References wibble::iterator().

## remove()

template<typename Token , typename Stream >

Token wibble::ParseContext< Token, Stream >::remove | ( |  | ) |

inline

References wibble::Token< _Id >::id.

## rewind()

template<typename Token , typename Stream >

void wibble::ParseContext< Token, Stream >::rewind | ( | int | n | ) |

inline

References assert.

## stream()

template<typename Token , typename Stream >

Stream& wibble::ParseContext< Token, Stream >::stream | ( |  | ) |

inline

References assert.

## Member Data Documentation

## _stream

template<typename Token , typename Stream >

Stream* wibble::ParseContext< Token, Stream >::_stream

## children

template<typename Token , typename Stream >

std::vector< This > wibble::ParseContext< Token, Stream >::children

## failures

template<typename Token , typename Stream >

std::priority_queue< Fail > wibble::ParseContext< Token, Stream >::failures

## name

template<typename Token , typename Stream >

std::string wibble::ParseContext< Token, Stream >::name

## position

template<typename Token , typename Stream >

int wibble::ParseContext< Token, Stream >::position

## window

template<typename Token , typename Stream >

std::deque< Token > wibble::ParseContext< Token, Stream >::window

## window_pos

template<typename Token , typename Stream >

int wibble::ParseContext< Token, Stream >::window_pos

The documentation for this struct was generated from the following file:

- parse.h